#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Fri Jan  8 21:02:00 2021

@author: wor
This file contains color tables definitions for various purposes.
Used to integrate across the whole project
- the plotting routines in covid19plotting.py
- the website color-coding of names etc for covid19webpages.py

"""
# table used to differentiate different max. daily death numbers for a province -easily changes

colorBreakpoints = [(10,     'tab:purple',  '#9467bd'),                         # defined in matplotlib.colors.TABLEAU_COLORS
                    (50,     'tab:blue',    '#1f77b4'),
                    (100,    'tab:cyan',    '#17becf'),
                    (200,    'tab:green',   '#2ca02c'),
                    (500,    'darkgoldenrod','#B8860B'),
                    (1000,   'tab:olive',   '#bcbd22'),
                    (1500,   'darkorange',  '#FF8C00'),
                    (2000,   'firebrick',   '#B22222'),
                    (3000,   'tab:red',     '#d62728'),
                    (10000,  'tab:pink',    '#e377c2')
                    ]                          # any rediculously high number (not used)

colorBreakpoints = [(10,     'tab:pink',    '#e377c2'),
                    (50,     'tab:purple',  '#9467bd'),                         # colors defined in matplotlib.colors.TABLEAU_COLORS
                    (100,    'tab:blue',    '#1f77b4'),
                    (200,    'tab:cyan',    '#17becf'),
                    (500,    'tab:green',   '#2ca02c'),
                    (1000,   'darkgoldenrod','#B8860B'),
                    (1500,   'tab:olive',   '#bcbd22'),
                    (2000,   'darkorange',  '#FF8C00'),
                    (3000,   'firebrick',   '#B22222'),
                    (10000,  'tab:red',     '#d62728')]                        # any rediculously high number will do (not used)


def selectColor(value, breakpoints=colorBreakpoints):
    # return a color string based on value breakpoints; 
    indx = 0 
    while True:
        if value <= breakpoints[indx][0]:                                      # the upper limit; include upper limit
            return breakpoints[indx][1]                                        # the color name (a string)
        else:
            indx += 1

# all from  here commented out
"""
#some alternative color-mappings
    breakpoints = [(10,    'tab:purple'), (50,    'tab:pink'), (100,    'tab:blue'),(200,    'tab:cyan'),
                   (500,    'tab:olive'), (1000,   'green'),  (1500,   'tab:orange'),
                   (20000,  'tab:red')]      # any reduculously high number
   breakpoints = [(10, 'violet'), (50, 'indigo'), (100, 'tab:blue'),(200,'tab:green'),(500,'darkgoldenrod'),
                   (1000,''), (1500,'darkorange'),(20000,'red')]      # any reduculously high number


see 
https://matplotlib.org/3.1.1/gallery/color/colormap_reference.html

https://matplotlib.org/3.1.0/gallery/color/named_colors.html
contains the following code that draws the color tables



# import named_colors



#tableau colors
('tab:blue', '#1f77b4'),
('tab:orange', '#ff7f0e'), 
('tab:green', '#2ca02c'), 
('tab:red', '#d62728'), 
('tab:purple', '#9467bd'), 
('tab:brown', '#8c564b'), 
('tab:pink', '#e377c2'), 
('tab:gray', '#7f7f7f'), 
('tab:olive', '#bcbd22'), 
('tab:cyan', '#17becf')])
#other colors defined in matplotlib.colors.CSS4_COLORS



#import matplotlib.colors as mcolors

mcolors.CSS4_COLORS
myCSScolorDict{'aliceblue': '#F0F8FF', 'antiquewhite': '#FAEBD7', 'aqua': '#00FFFF', 'aquamarine': '#7FFFD4',
 'azure': '#F0FFFF', 'beige': '#F5F5DC', 'bisque': '#FFE4C4', 'black': '#000000',
 'blanchedalmond': '#FFEBCD', 'blue': '#0000FF', 'blueviolet': '#8A2BE2', 'brown': '#A52A2A',
 'burlywood': '#DEB887', 'cadetblue': '#5F9EA0', 'chartreuse': '#7FFF00', 'chocolate': '#D2691E',
 'coral': '#FF7F50', 'cornflowerblue': '#6495ED', 'cornsilk': '#FFF8DC', 'crimson': '#DC143C', 
 'cyan': '#00FFFF', 'darkblue': '#00008B', 'darkcyan': '#008B8B', 'darkgoldenrod': '#B8860B', 
 'darkgray': '#A9A9A9', 'darkgreen': '#006400', 'darkgrey': '#A9A9A9', 'darkkhaki': '#BDB76B',
 'darkmagenta': '#8B008B', 'darkolivegreen': '#556B2F', 'darkorange': '#FF8C00', 
 'darkorchid': '#9932CC', 'darkred': '#8B0000', 'darksalmon': '#E9967A', 'darkseagreen': '#8FBC8F',
 'darkslateblue': '#483D8B', 'darkslategray': '#2F4F4F', 'darkslategrey': '#2F4F4F',
 'darkturquoise': '#00CED1', 'darkviolet': '#9400D3', 'deeppink': '#FF1493', 'deepskyblue': '#00BFFF',
 'dimgray': '#696969', 'dimgrey': '#696969', 'dodgerblue': '#1E90FF', 'firebrick': '#B22222',
 'floralwhite': '#FFFAF0', 'forestgreen': '#228B22', 'fuchsia': '#FF00FF', 'gainsboro': '#DCDCDC',
 'ghostwhite': '#F8F8FF', 'gold': '#FFD700', 'goldenrod': '#DAA520', 'gray': '#808080',
 'green': '#008000', 'greenyellow': '#ADFF2F', 'grey': '#808080', 'honeydew': '#F0FFF0',
 'hotpink': '#FF69B4', 'indianred': '#CD5C5C', 'indigo': '#4B0082', 'ivory': '#FFFFF0',
 'khaki': '#F0E68C', 'lavender': '#E6E6FA', 'lavenderblush': '#FFF0F5', 'lawngreen': '#7CFC00',
 'lemonchiffon': '#FFFACD', 'lightblue': '#ADD8E6', 'lightcoral': '#F08080', 'lightcyan': '#E0FFFF',
 'lightgoldenrodyellow': '#FAFAD2', 'lightgray': '#D3D3D3', 'lightgreen': '#90EE90',
 'lightgrey': '#D3D3D3', 'lightpink': '#FFB6C1', 'lightsalmon': '#FFA07A', 'lightseagreen': '#20B2AA',
 'lightskyblue': '#87CEFA', 'lightslategray': '#778899', 'lightslategrey': '#778899',
 'lightsteelblue': '#B0C4DE', 'lightyellow': '#FFFFE0', 'lime': '#00FF00', 'limegreen': '#32CD32',
 'linen': '#FAF0E6', 'magenta': '#FF00FF', 'maroon': '#800000', 'mediumaquamarine': '#66CDAA',
 'mediumblue': '#0000CD', 'mediumorchid': '#BA55D3', 'mediumpurple': '#9370DB',
 'mediumseagreen': '#3CB371', 'mediumslateblue': '#7B68EE', 'mediumspringgreen': '#00FA9A',
 'mediumturquoise': '#48D1CC', 'mediumvioletred': '#C71585', 'midnightblue': '#191970',
 'mintcream': '#F5FFFA', 'mistyrose': '#FFE4E1', 'moccasin': '#FFE4B5', 'navajowhite': '#FFDEAD',
 'navy': '#000080', 'oldlace': '#FDF5E6', 'olive': '#808000', 'olivedrab': '#6B8E23',
 'orange': '#FFA500', 'orangered': '#FF4500', 'orchid': '#DA70D6', 'palegoldenrod': '#EEE8AA',
 'palegreen': '#98FB98', 'paleturquoise': '#AFEEEE', 'palevioletred': '#DB7093',
 'papayawhip': '#FFEFD5', 'peachpuff': '#FFDAB9', 'peru': '#CD853F', 'pink': '#FFC0CB',
 'plum': '#DDA0DD', 'powderblue': '#B0E0E6', 'purple': '#800080', 'rebeccapurple': '#663399',
 'red': '#FF0000', 'rosybrown': '#BC8F8F', 'royalblue': '#4169E1', 'saddlebrown': '#8B4513',
 'salmon': '#FA8072', 'sandybrown': '#F4A460', 'seagreen': '#2E8B57', 'seashell': '#FFF5EE',
 'sienna': '#A0522D', 'silver': '#C0C0C0', 'skyblue': '#87CEEB', 'slateblue': '#6A5ACD',
 'slategray': '#708090', 'slategrey': '#708090', 'snow': '#FFFAFA', 'springgreen': '#00FF7F',
 'steelblue': '#4682B4', 'tan': '#D2B48C', 'teal': '#008080', 'thistle': '#D8BFD8',
 'tomato': '#FF6347', 'turquoise': '#40E0D0', 'violet': '#EE82EE', 'wheat': '#F5DEB3',
 'white': '#FFFFFF', 'whitesmoke': '#F5F5F5', 'yellow': '#FFFF00', 'yellowgreen': '#9ACD32'}
 
"""

# ======= Test code for various things - including colors and tables: copied from  testpage.py 
"""
# choose one: 
global ORANGE_STICK ; ORANGE_STICK  = False                                     # the USB stick
global MBP_288      ; MBP_288       = True                                      # the Fraunhofer MacBook
global AAA_DWOR     ; AAA_DWOR      = False                                     # The AAA/CCC MacBook
if ORANGE_STICK:
    rootDirectory  = '/volumes/DRWORANGE32/COVID-19/'
elif MBP_288:
    rootDirectory  = '/Users/wor/documents/RESEARCH projects/COVID-19/'
elif AAA_DWOR:
    rootDirectory  = '/Users/davidworrall/Documents/RESEARCH/COVID-19/'
else:
    print ('\n ======== ROOT DIRECTORY NOT FOUND FOR COVID-19 PROJECT ======\n')
    
websiteDirectory = rootDirectory + 'website/'                                     #  for website
imageDirectory  = rootDirectory + 'graphImages/deaths_global/'                   # for non-website images
dataDirectory   = rootDirectory + 'dataSets/'                                    # root directory  for data


#  table template with Yattag

from yattag import Doc
doc, tag, text, line = Doc().ttl()   # equiv to doc = Doc(); tag = doc.tag; text = doc.text etc

#from covid19plotting import colorBreakpoints                                   # why does this run the plotting routine
from colorTables import colorBreakpoints


colorBreakpoints = [(10,     'tab:purple',  '#9467bd'),                             # defined in matplotlib.colors.TABLEAU_COLORS
                    (50,     'tab:blue',    '#1f77b4'),
                    (100,    'tab:cyan',    '#17becf'),
                    (200,    'tab:green',   '#2ca02c'),
                    (500,    'darkgoldenrod','#B8860B'),
                    (1000,   'tab:olive',   '#bcbd22'),
                    (1500,   'darkorange',  '#FF8C00'),
                    (2000,   'firebrick',   '#B22222'),
                    (10000,  'tab:red',     '#d62728')                          # any rediculously high number (not used)
                    ]




def getTableColors(breakpoints=colorBreakpoints):
    # sets up the matplotlib legend table to itemize (by default) a color table
    # of max deaths/day - as set in the colorBreakpoints list
    legendColors = []
    legendLabels = []
    lowerLimit = 0                                                            # charts not generated for 0 deaths
    for indx in range (len (breakpoints)):
        legendColors += [colorBreakpoints[indx][2]]                         
        legendLabels += [str(lowerLimit+1)+' to ' + str(colorBreakpoints[indx][0])] # the lower limit of this color's range
        lowerLimit = breakpoints[indx][0]
        if indx == len (breakpoints) -1:                                       # kluge to change last label
            legendLabels[-1] = str (breakpoints[-2][0]+1)+' & above'
    return legendColors, legendLabels

legendColors, legendLabels = getTableColors()

       #    maxLabelLen = len(max (legendLabels, key=len))                             # the longest label text
#print ("legendColors:", legendColors)
#print ("legendLabels:", legendLabels)
def makeColorTable():
    with tag ('table',  border="1px", style="background-color:#FFFFFF;"):
        with tag ('caption'):
            text ("Table of color-codes for max. nr. deaths/days.")
        with tag('tr'):
            with tag ('th'):
                text('Color')
            with tag ('th'):
                text ('Max. Daily Death rate')
        
        for colorNr in range (len (colorBreakpoints)):
            with tag ('tr'):
                with tag('td', width='70', style="background-color:"+legendColors[colorNr]+";"):
                    pass #text(str(colorNr))
                with tag('td', width='70', style="text-align:right;"):
                    text ( legendLabels[colorNr])

    
doc.asis ('<!DOCTYPE html>')
doc.asis('\n')
with tag('html'):
    doc.asis('\n')
    with tag ('head'):
        doc.asis('\n')
        with tag ('title'):
            text('COVID-19 Perceptualization')
        doc.asis('\n')
        with tag('style'):
            text('\n')
            text('body {'
                    +'\nbackground-color: #f0f8f0;'
                    +'\ncolor: black;'
                    + 'font-size:12px;'
                    + 'width: 900px;'
                    + 'topmargin: 0;' 
                    + 'leftmargin: 0;' 
#                    + 'height:480px;'
#                    + 'style=font-size:12px; color:red; font-weight:normal; font-style:plain; color: rgb(1, 1, 1);'
#                    +'background-color: rgb(88, 88,88;'
                    + 'marginheight:0; marginwidth:0;'
                    + '}'
                    )
    doc.asis('\n')
    with tag('body'):
        with tag('p'):
            text("hello world!")
#        with tag ('table',  border = "2px",  "background-color:blue;"): 
        with tag ('table',  border="2px", style="background-color:#FFFFFF;"): 
            # cellpadding :1; cellspacing:1; width: 900;height: 400;"):
            with tag ('tr'):
                with tag('td', width='300', style="background-color:#FF0000;"):
                    with tag ('p'): 
                        text(" Upper Left colum")
                with tag('td', width='300'):
                    with tag ('p'):
                        text(" Upper Center colum")
                with tag('td', width='300'):
                    with tag ('p'):
                        text(" Upper Right colum")
            with tag ('tr'):
                with tag('td', width='300'):
                    with tag ('p'):
                        text(" Lower Left colum")
                with tag('td', width='300'):
                    with tag ('p'):
                        text(" Lower Center colum")
                with tag('td', width='300'):
                    with tag ('p'):
                        text(" Lower Right colum")
        makeColorTable()



testpage = open (websiteDirectory+'testpage.html', 'w')
testpage.write (doc.getvalue())
testpage.close()

"""